/***************************************************************************
                          mainwindow.h  -  description
                             -------------------
    begin                : Wed Mar 20 2002
    copyright            : (C) 2002 by Michael Herder
    email                : crapsite@gmx.net
 ***************************************************************************/

/*******************************************************************************
 *                                                                             *
 * This file is part of the example program "plugintest", which demonstrates   *
 * the usage of the QuiteInsane-Plugin.                                        *
 * It may be used, distributed and modified without limitation.                *
 *                                                                             *
 *******************************************************************************/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <qimage.h>
#include <qmainwindow.h>
#include <qstring.h>

/**
  *@author Michael Herder
  */
//add the typedef here; it's needed to access the plugins init function
typedef bool (*quiteInsaneProc)(QWidget*);

class QLabel;

class MainWindow : public QMainWindow
{
Q_OBJECT
public: 
	MainWindow(QWidget* parent=0,const char* name=0);
	~MainWindow();
private:
  QString mDeviceName;
  QLabel* mpLabel;
public slots:
  /**An application that wants to use the QuiteInsane-Plugin must
     supply the following two (public !) slots */
  /** No descriptions */
  void slotQisNewDeviceName(QString device_name);
  /** No descriptions */
  void slotQisScanReady(QPtrList<QImage>&);
private slots:
  /** No descriptions */
  void slotSetupScanner();
  /** No descriptions */
  void slotScanImage();
signals:
  /**An application that wants to use the QuiteInsane-Plugin must
     supply the following two signals */
  /** No descriptions */
  void signalQisScanImage(QString device_name,bool allow_multiple_scans);
  /** No descriptions */
  void signalQisGetDeviceName();
};

#endif
