/***************************************************************************
                          quiteinsaneplugin.h  -  description
                             -------------------
    begin                : Fri Mar 22 2002
    copyright            : (C) 2002 by Michael Herder
    email                : crapsite@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QUITEINSANEPLUGIN_H
#define QUITEINSANEPLUGIN_H

#include <qimage.h>
#include <qmap.h>
#include <qptrlist.h>
#include <qstring.h>
#include <qwidget.h>

/**
  *@author Michael Herder
  */
class QScanDialog;
class QScanner;
class QScannerSetupDlg;

class QuiteInsanePlugin : public QObject
{
Q_OBJECT
public: 
	QuiteInsanePlugin(QWidget* parent);
	~QuiteInsanePlugin();
  /** No descriptions */
  bool isInit();
private:
  /**  */
  bool mIsInit;
  /**  */
  QMap <QString,QString> mOptionMap;
  /**  */
  QString mDeviceName;
  /**  */
  QScanner* mpScanner;
  /**  */
  QScannerSetupDlg* mpScannerSetupDialog;
  /**  */
  QScanDialog* mpScanDialog;
public slots:
  /** No descriptions */
  void slotQisScanImage(QString device_name,bool allow_multiple_scans);
  /** No descriptions */
  void slotQisGetDeviceName();
signals:
  /** No descriptions */
  void signalQisNewDeviceName(QString device_name);
  /** No descriptions */
  void signalQisScanReady(QPtrList <QImage>& il);
private: // Private methods
  /** No descriptions */
  QString getDeviceName();
  /** No descriptions */
  bool initPlugin();
  /** No descriptions */
  void loadLastSettings();
};

#endif
